function reorderDragDrop(itemPattern, tableId, formId, orderedIds) {
    var ctf = {}; // create a namespace for ctf objects
    var Event = YAHOO.util.Event;
    var pattern = new RegExp(itemPattern);

    // Note:  Buttons named *2 are TOP Buttons

    ctf.prevSib = function(el) {
        var prev = el.previousSibling;
        // need to make sure the previous sibling is a text
        while (prev.nodeType != 1) {
            prev = prev.previousSibling;
        }
        return prev;
    };

    ctf.nextSib = function(el) {
        var sib = el.nextSibling;
        // need to make sure the sibling is an element type
        while (sib.nodeType != 1) {
            sib = sib.nextSibling;
        }
        return sib;
    };

    ctf.DDApp = {
        init: function() {
            // make all the table rows drag and droppable
            var tableElem = YAHOO.util.Dom.get(tableId);
            var items = tableElem.getElementsByTagName("tr");
            for (var i=0;i<items.length;i=i+1) {
                if (items[i].id.match(pattern)) {
                    new ctf.DDItem(items[i].id);
                }
            }

            document.getElementById(formId).hasChanges.value = "false";
            Event.on("_SfButton_applychanges", "click", function() {
                var items = YAHOO.util.Dom.get(tableId).getElementsByTagName("tr");
                var out = ""
                for (var i=0;i<items.length;i++) {
                    if (items[i].id.match(pattern)) {
                        out += items[i].id + ",";
                    }
                }
                document.getElementById(formId).elements[orderedIds].value = out.substring(0, out.length-1);
            });

            document.getElementById(formId).hasChanges.value = "false";
            Event.on("_SfButton_applychanges2", "click", function() {
                var items = YAHOO.util.Dom.get(tableId).getElementsByTagName("tr");
                var out = ""
                for (var i=0;i<items.length;i++) {
                    if (items[i].id.match(pattern)) {
                        out += items[i].id + ",";
                    }
                }
                document.getElementById(formId).elements[orderedIds].value = out.substring(0, out.length-1);
            });
        }
        };

    ctf.DDItem = function(id) {
        if (id) {
            this.init(id);
            this.initFrame();
        }
        var s = this.getDragEl().style;
        s.borderColor = "transparent";
        s.backgroundColor = "#f6f5e5";
        s.opacity = 0.76;
        s.filter = "alpha(opacity=76)";
        this.lastOverId = '';
    };

    YAHOO.extend(ctf.DDItem, YAHOO.util.DDProxy, {
        startDrag: function(x, y) {
            var dragEl = this.getDragEl();
            var clickEl = this.getEl();

            dragEl.innerHTML = clickEl.innerHTML;
            dragEl.className = clickEl.className;
            dragEl.style.color = clickEl.style.color;
            dragEl.style.border = "1px solid blue";
        },
        endDrag: function(e) {},
        onDragDrop: function(e, id) {
            this.lastOverId = ''; // reset this value
            document.getElementById(formId).hasChanges.value = "true";
            $j("#" + tableId + " tr[class='OddRow']").addClass('EvenRow');
            $j("#" + tableId + " tr[class='EvenRow']").addClass('OddRow');
            // Odds are marked as evens and vice-versa
            $j("#" + tableId + " tr.OddRow:odd").removeClass('OddRow');
            $j("#" + tableId + " tr.EvenRow:even").removeClass('EvenRow');
        },
        onDrag: function(e, id) {},
        onDragOver: function(e, id) {
            var el;
            if ("string" == typeof id) {
                el = YAHOO.util.DDM.getElement(id);
            } else {
                el = YAHOO.util.DDM.getBestMatch(id).getEl();
            }

            // since this event is fired continuously, we need to make it slightly more efficient. So keep track
            // of the last id that we've entered and short circuit this function call if that hasn't changed
            if (this.lastOverId != '' && this.lastOverId == id) {
                return;
            }

            var parentNode = el.parentNode;
            var draggedEl = this.getEl();

            if (draggedEl.id == ctf.prevSib(el).id) {
                parentNode.insertBefore(draggedEl, ctf.nextSib(el));
            } else {
                parentNode.insertBefore(draggedEl, el);
            }

            this.target = parentNode.id;
            setButtonState("_SfButton_applychanges", "enabled");
            setButtonState("_SfButton_discardchanges", "enabled");
            if (document.getElementById("_SfButton_applychanges2") != undefined) {
                setButtonState("_SfButton_applychanges2", "enabled");
            }
            if (document.getElementById("_SfButton_discardchanges2") != undefined) {
                setButtonState("_SfButton_discardchanges2", "enabled");
            }

            this.lastOverId = id;
        },

        onDragEnter: function(e, id) {
            this.getDragEl().style.border = "1px solid #449629";
        }
    });

    Event.onDOMReady(ctf.DDApp.init, ctf.DDApp, true);
}
